#ifndef CUTSURFACES_H
#define CUTSURFACES_H

#include <stdio.h>
#include <stdlib.h>
#include "DrawingObjects.h"
#include "Surfaces.h"
#include "Interpolator.h"


/** Class for a temporary cut plane
 *
 *  It is assumed that vertices will be changed if the plane is moved as
 *  well as all the elements
 */
class CutSurfaces : public Surfaces
{
  public:
    CutSurfaces(GLfloat *n);
    ~CutSurfaces();
    void get_vert_norms( GLfloat *vn ){}
    void determine_vert_norms( PPoint & ){}
    void addEle( SurfaceElement *e, Interpolator<DATA_TYPE>*, int=-1 );
    DATA_TYPE  interpolate( int e, DATA_TYPE *d, int p )
    {
      return _interp[e][p].interpolate( d );
    }
    DATA_TYPE  interpolate( int e, DATA_TYPE *d, int p, double *bc )
    {
      return _interp[e][p].interpolate( d, bc );
    }
    const GLfloat* norm(){ return _norm; }
    void clear(GLfloat *n =NULL); 
    bool fresh(){return _fresh;}
    void fresh( bool f ) { _fresh = f; }
    GLfloat* allocate_buffer(){count_tris(); _rd.buffer(numtri()); _rd.opaque(-1); 
                                                             return _rd.buffer();} 
    GLfloat* buffer(){return _rd.buffer();} 
    void init_buff(void *c){_rd.setup_render_data(c);}
    void update_buff(){_rd.update_nodalbuff();}
    void render(){_fresh=false;_rd.mesh_render(false);}
    void recolor( const GLfloat *col, bool );
    void translucent( bool tl ){ if(tl){_rd.opaque(0);}else{_rd.opaque(-1);}}

  protected:
    vector<GLfloat*>                 _ptarr;
    GLfloat                          _norm[3];
    vector<Interpolator<DATA_TYPE>*> _interp;
    bool                             _fresh = true;
    RenderTris _rd;
};

#endif
