#ifndef LEGACY_GL_H
#define LEGACY_GL_H

#include "Quaternion.h"

#  if defined(__APPLE__)
#  define GL_SILENCE_DEPRECATION
#    include <OpenGL/gl3.h> // defines OpenGL 3.0+ functions
#  else
#    include <FL/gl.h>
#  endif
#include <map>

#define NUM_CP 6

extern       GLfloat CLIP_EQN[NUM_CP][4];
extern const GLenum  CLIP_PLANE[];
extern const GLenum  CLIP_DISTANCE[];

extern map<void*,Quaternion> LightDir;
extern map<void*,M4f> ModelViewMat;
extern map<void*,M4f> ProjectionMat;

void ortho_proj(void*, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat, GLfloat);
void light_dir( void *, const Quaternion& );
inline Quaternion light_dir( void *cntxt ){ return LightDir[cntxt]; }
void translate_mv( void*, GLfloat x, GLfloat y, GLfloat );
void scale_mv( void*, GLfloat x, GLfloat y, GLfloat z );
void mult_mv( void*, M4f m );
void identity_mv(void*);
bool clip_on( int );
void clip_on( bool * );
bool clip_off( int );
void clip_off( bool * );
bool clipping( int );
void clip_eqn( int i, GLfloat* coeffs );

#endif
